
QGIS Application - Bug report #15985

Concave hull not working in Processing (QGIS3)

2016-12-15 01:50 AM - matteo ghetta

Status: Closed

Priority: High

Assignee: Nyall Dawson

Category: Processing/QGIS

Affected QGIS version:master Regression?: Yes

Operating System: Linux mint Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 23901

Description

Concave hull algorithm always throws an error. In QGIS 2.18 it works fine (tested with point data within the processing test framework)

2016-12-15T10:47:55    2    Uncaught error while executing algorithm

Traceback (most recent call last):

File "/home/matteo/lavori/QGIS/build-qgis3/output/python/plugins/processing/core/GeoAlgorithm.py", line 213, in execute

self.processAlgorithm(progress)

File "/home/matteo/lavori/QGIS/build-qgis3/output/python/plugins/processing/algs/qgis/ConcaveHull.py", line 76, in processAlgorithm

features = delaunay_layer.getFeatures()

AttributeError: 'NoneType' object has no attribute 'getFeatures'

Associated revisions

Revision e232a080 - 2017-05-02 05:04 PM - Arnaud Morvan

[processing] Handle context in processing.run

Fix #15985 (Concave hull)

History

#1 - 2017-01-04 06:06 AM - Giovanni Manghi

- Priority changed from Normal to Severe/Regression

#2 - 2017-02-07 06:29 AM - Alexander Bruy

This happens because now temporary layers are memory layers and Processing fails to locate algorithm result

#3 - 2017-02-14 01:27 AM - matteo ghetta

Ok, any chance or way to fix this? Can I help making other tests?

Thanks again!

#4 - 2017-04-29 01:38 AM - Arnaud Morvan

For now, with Nyall work on porting processing to c++.

The processing.run method create a QgsProcessingContext (in Processing.runAlgorithm) and the ouput, some memory layer is placed in 
context.temporaryStore.

But it is not possible to pass the parent (caller) algorithm context to processing.run so it is not possible to get back the layer object.

I see the possibility to add a context parameter to processing.run, like is done with feedback.

#5 - 2017-04-29 03:32 AM - Arnaud Morvan

Here is a pull request that highlight the situation : https://github.com/qgis/QGIS/pull/4439

It fix the error, but Nyall may have other plans.

#6 - 2017-04-29 05:00 AM - Arnaud Morvan

- Assignee changed from Victor Olaya to Nyall Dawson

#7 - 2017-04-30 05:06 PM - Giovanni Manghi

- Regression? set to Yes

#8 - 2017-04-30 05:08 PM - Giovanni Manghi

- Priority changed from Severe/Regression to High

#9 - 2017-05-01 01:10 AM - Giovanni Manghi

- Easy fix? set to No

#10 - 2017-05-02 09:49 PM - Arnaud Morvan

- % Done changed from 0 to 100

- Status changed from Open to Closed

Applied in changeset commit:qgis|e232a0809c8367d9b1f78b2d399f7a3c85291594.
